#Include "DeGui.bi"
#Include "LoadSaveDialog.bi"
#Include "LoadImgFile.bi"
#Include "Windows.bi"
#Include "file.bi"

#Define ESC &h01

ScreenRes 640, 50, 32
Color &hFFFFFF, &hDDDDDD
CLS

Dim as TimeControlUDT FPS = TimeControlUDT(60)

Declare Sub ButtonEv(ID as String)
Declare Sub CreateResFile()
Declare Function DelSpace(Text as String) as String

Dim as GUI G
Dim Shared as RollTextField PTR InFileName, OutFileName

InFileName  = G.GetRollTextFieldPTR(G.NewRollTextField(10, 10, 50))
OutFileName = G.GetRollTextFieldPTR(G.NewRollTextField(10, 30, 50, "Unnamed.bi"))
G.NewButton("Chose File", 450, 10, "CF", @ButtonEv)
G.NewButton("Start", 450, 30, "Start", @ButtonEv)
G.NewButton("Exit", 500, 30, "Exit", @ButtonEv)

While(NOT Multikey(ESC))
    G.Control()
    ScreenLock
        CLS
        G.G()
    ScreenUnlock
    
    FPS.ControlTime()
Wend

'###############################################################################
Sub ButtonEv(ID as String)
    Dim as Integer a, Last
    
    If ID = "CF" then
        InFileName->Text = LoadSaveDialog(, "BMP Dateien (*.BMP)" + CHR(0) + "*.BMP" + CHR(0, 0))
        
        For a = 1 to Len(InFileName->Text)
            If Mid(InFileName->Text, a, 1) = "\" then Last = a
        Next a
        OutFileName->Text = Mid(InFileName->Text, Last + 1)
        OutFileName->Text = Mid(OutFileName->Text, 1, Len(OutFileName->Text) - 4)
        OutFileName->Text = "Res" + OutFileName->Text + ".bi"
    ElseIf ID = "Start" then
        CreateResFile()
    ElseIf ID = "Exit" then
        End 0 
    Endif
End Sub

'###############################################################################
Sub CreateResFile()
    Dim as Any PTR BMP
    Dim as UInteger Farbe
    
    BMP = LoadImgFile(InFileName->Text)
    If BMP = 0 then
        MessageBox(0, "Something went wrong while loading File." + CHR(13, 10) + "Maybe the filename wasnt correct.", "Error", MB_ICONERROR OR MB_OK)
        Exit Sub
    Endif
    
    Dim as Integer ImgWidth, ImgHeight
    ImageInfo(BMP, ImgWidth, ImgHeight)
    Dim as UInteger a, b
    Dim as UByte Red(0 to ImgWidth, 0 to ImgHeight), Green(0 to ImgWidth, 0 to ImgHeight), Blue(0 to ImgWidth, 0 to ImgHeight), AlphaW(0 to ImgWidth, 0 to ImgHeight)
    Dim as Integer File
    Dim as Integer Ret
    Dim as Byte FileNE
    
    For a = 0 to ImgHeight - 1
        For b = 0 to ImgWidth - 1
            Farbe = Point(b, a, BMP)
            AlphaW(b, a) = HIBYTE (HIWORD (Farbe))
            Red(b, a)    = LOBYTE (HIWORD (farbe))
            Green(b, a)  = HIBYTE (LOWORD (farbe))
            Blue(b, a)   = LOBYTE (LOWORD (farbe))
        Next b
    Next a
    
    If Fileexists(OutFileName->Text) = -1 then 
        Ret = MessageBox(0, "This file allready exists! Overwrite?", "Error", MB_ICONERROR OR MB_YESNO)
        If Ret = IDNO then Exit Sub
    Else
        FileNE = 1
    Endif
    
    If Ret = IDYES Or FileNE = 1 then
        File = Freefile
        If Open(OutFileName->Text for Output as #File) = 0 then
            Print #File, DelSpace(OutFileName->Text) + ":"
            Print #File, "Data " + STR(ImgWidth)
            Print #File, "Data " + STR(ImgHeight)
            For a = 0 to ImgHeight - 1
                For b = 0 to ImgWidth - 1
                    Print #File, "Data " + STR(AlphaW(b, a)) + ", " + STR(Red   (b, a)) + ", " + STR(Green (b, a)) + "," + STR(Blue  (b, a))
                Next b
            Next a
            Close #File
            
            MessageBox(0, "Done!", "OK", MB_ICONINFORMATION OR MB_OK)
        Else
            MessageBox(0, "Error! Could not open output file!", "Error", MB_ICONERROR OR MB_OK)
        Endif
    Endif
End Sub 

'###############################################################################
Function DelSpace(Text as String) as String
    Dim as Integer a
    
    Text = Trim(Text)
    For a = 1 to LEN(Text)
        If ASC(Mid(Text, a, 1)) >= 32 And ASC(Mid(Text, a, 1)) <= 47 then Mid(Text, a, 1) = "_"
    Next a
    
    Return Text
End Function
