'-----------LoadSaveDialog.inc
'Nutzt den komfortablen Window-Dialog zur Auswahl des Laufwerk/Pfad/Dateinamens
'zum ffnen oder speichern einer Datei.
'13.03.2006 - WIN32 console application - by Volta
'21.08.2006 - FB 0.16b - fr XP Bugs entfernt, einige Verbesserungen - by Volta
'15.06.2007 - FB 0.17b(FB 0.18) - erweitert auf fbgfx-Window - by Volta
'hat unter ME Probleme im Fullscreen-Modus (teilweise wird Print nicht ausgefhrt?)

#INCLUDE ONCE "windows.bi"
#INCLUDE ONCE "win\commdlg.bi"
#IFDEF __fbgfx_bi__
  ' Some defines and typedefs for the Win32Driver structure
  #DEFINE WINDOW_TITLE_SIZE   128
  #DEFINE WINDOW_CLASS_PREFIX "fbgfxclass_"
  ' Structure containing GfxLib's internal Windows info FB 0.18
  TYPE WIN32DRIVER
      Version             AS INTEGER
      hInstance           AS HINSTANCE
      WndClass            AS WNDCLASS
      Wnd                 AS HWND
      PALETTE(0 TO 255)   AS PaletteEntry
      Blitter             AS SUB(BYVAL AS UBYTE PTR, BYVAL AS INTEGER)
      IS_Running          AS INTEGER
      IS_Palette_Changed  AS INTEGER
      IS_Active           AS INTEGER
      w                   AS INTEGER
      h                   AS INTEGER
      Depth               AS INTEGER
      flags               AS INTEGER
      Refresh_Rate        AS INTEGER
      WINDOW_Title        AS UBYTE PTR
      WindowClass(0 TO WINDOW_TITLE_SIZE + SIZEOF(WINDOW_CLASS_PREFIX)-1) AS UBYTE
      Init AS FUNCTION()  AS INTEGER
      EXIT AS FUNCTION()  AS INTEGER
      PAINT AS FUNCTION() AS INTEGER
      Thread              AS SUB(BYVAL Running_Event AS HANDLE)
      mouse_clip          AS INTEGER
  END TYPE
  EXTERN FB_Win32 ALIAS "fb_win32" AS WIN32DRIVER
#ENDIF

DECLARE FUNCTION LoadSaveDialog (_
           BYVAL savedlog AS INTEGER = 0,_
           BYVAL filter AS STRING = "",_
           BYVAL fltrindex AS INTEGER = 1,_
           BYVAL initdir AS STRING = ".",_
           BYVAL strDefExt AS STRING = "") AS STRING
'Voreinstellungen: LoadSaveDialog(0, "", 1, ".", "")
' savedlog = 0 -> Datei ffnen, 1(<>0) -> Datei Speichern
'   filter = "" -> Alle Dateien, sonst siehe lsd_fil
'fltrindex = 1,  sonst welcher Eintrag, der bei filter angegebenen Auswahl, aktiv ist
'  initdir = "" = "." aktueller Pfad, sonst Pfad angeben
'strDefExt = "" keine Vorgabe, sonst z.B. "bak" als Vorgabe der Endung zum Speichern

FUNCTION LoadSaveDialog (BYVAL savedlog AS INTEGER, BYVAL filter AS STRING, _
                         BYVAL fltrindex AS INTEGER, BYVAL initdir AS STRING, _
                         BYVAL strDefExt AS STRING) AS STRING
  DIM AS ZSTRING *MAX_PATH Titel = ""
  DIM FB_OFN AS OPENFILENAME
   FB_OFN.lStructSize = SIZEOF(FB_OFN)
  #IFDEF __fbgfx_bi__
     FB_OFN.hwndOwner = FB_Win32.Wnd
     FB_OFN.hInstance = FB_Win32.hInstance
  #ENDIF
  #IFNDEF __fbgfx_bi__
     GetConsoleTitle (@Titel, MAX_PATH)
     FB_OFN.hwndOwner = FindWindow( 0, Titel )
     FB_OFN.hInstance = 0
  #ENDIF

   DIM strFilter AS STRING = "Alle Dateien (*.*)" + CHR(0) +"*.*" + CHR(0, 0) 'Vorgabe
   IF filter = "" THEN
      FB_OFN.lpstrFilter = STRPTR(strFilter)
   ELSE
      FB_OFN.lpstrFilter = STRPTR(filter)
   END IF

   FB_OFN.nFilterIndex = fltrindex

   DIM AS STRING *1024 strFile = SPACE(1023)+ CHR(0)
   FB_OFN.lpstrFile = STRPTR(strFile)
   FB_OFN.nMaxFile = SIZEOF(strFile)

   DIM AS STRING *1024 strFileTitle = STRING(1023,CHR(0))
   FB_OFN.lpstrFileTitle = STRPTR(strFileTitle)
   FB_OFN.nMaxFileTitle = LEN(strFileTitle)

   IF initdir = "" THEN
      initdir = "."     ' Vorgabe aktueller Pfad
   END IF
   FB_OFN.lpstrInitialDir = STRPTR(initdir)

   DIM AS STRING strcapt = "Datei ffnen"
   IF savedlog THEN
      strcapt = "Datei Speichern"
      FB_OFN.lpstrTitle = STRPTR(strcapt)
      FB_OFN.lpstrDefExt = STRPTR(strDefExt)
      FB_OFN.flags = OFN_EXPLORER OR OFN_LONGNAMES OR _
                     OFN_OVERWRITEPROMPT OR OFN_HIDEREADONLY
      IF GetSaveFileName(@FB_OFN) THEN LoadSaveDialog = TRIM(strFile)
   ELSE
      FB_OFN.lpstrTitle = STRPTR(strcapt)
      FB_OFN.flags = OFN_EXPLORER OR OFN_LONGNAMES OR OFN_CREATEPROMPT OR _
                     OFN_NODEREFERENCELINKS OR OFN_HIDEREADONLY
      IF GetOpenFileName(@FB_OFN) THEN LoadSaveDialog = TRIM(strFile)
   END IF
END FUNCTION
'-Ende----------LoadSaveDialog.inc